package com.fp.persistence.pcustomer.company;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TCUSTFAMILIARLLINK*/
@Embeddable
public class TcustFamiliarlLinkKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="PERSONCODE", nullable=false,updatable=false)

/**
* Codigo de persona
*/
private Integer personcode;

@Column(name="LINKPERSONCODE", nullable=false,updatable=false)

/**
* Codigo de persona
*/
private Integer linkpersoncode;

/**Contructor por defecto*/
public TcustFamiliarlLinkKey(){}
/**Contructor de TcustFamiliarlLinkKey
@param pPersoncode Codigo de persona
@param pLinkpersoncode Codigo de persona
*/
public TcustFamiliarlLinkKey(Integer pPersoncode,Integer pLinkpersoncode){
 personcode=pPersoncode;
 linkpersoncode=pLinkpersoncode;
}
/**Obtiene el valor de personcode
@return valor de personcode*/
public Integer getPersoncode(){
  return personcode;
}
/**Fija el valor de personcode
@param pPersoncode nuevo Valor de personcode*/
public void setPersoncode(Integer pPersoncode){
  personcode=pPersoncode;
}

/**Obtiene el valor de linkpersoncode
@return valor de linkpersoncode*/
public Integer getLinkpersoncode(){
  return linkpersoncode;
}
/**Fija el valor de linkpersoncode
@param pLinkpersoncode nuevo Valor de linkpersoncode*/
public void setLinkpersoncode(Integer pLinkpersoncode){
  linkpersoncode=pLinkpersoncode;
}

/**Implementación de la comparación de TcustFamiliarlLinkKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TcustFamiliarlLinkKey))return false;
  TcustFamiliarlLinkKey that = (TcustFamiliarlLinkKey) o;
  if (this.getPersoncode() == null || that.getPersoncode() == null){
      return false;
  }
  if (! this.getPersoncode().equals(that.getPersoncode())){
    return false;
  }
  if (this.getLinkpersoncode() == null || that.getLinkpersoncode() == null){
      return false;
  }
  if (! this.getLinkpersoncode().equals(that.getLinkpersoncode())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TcustFamiliarlLinkKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getPersoncode() == null ? 0 : this.getPersoncode().hashCode());
    result = result * 37 + (this.getLinkpersoncode() == null ? 0 : this.getLinkpersoncode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
